=== modified file 'NEWS'
--- NEWS	2007-01-04 15:37:11 +0000
+++ NEWS	2007-01-08 17:08:42 +0000
@@ -1,3 +1,6 @@
+Jan 8 2007
+* 'import' now imports directories.
+
 Jan 4 2007
 * 'cbranch' now supports multilevel paths.  So your repo hierarchy can match
   your working directory hierarchy exactly.  New config option must be

=== modified file 'tests/blackbox.py'
--- tests/blackbox.py	2006-09-25 13:15:48 +0000
+++ tests/blackbox.py	2007-01-08 17:08:42 +0000
@@ -128,6 +128,7 @@
         self.runbzr('commit -m hello')
         self.runbzr('export ../source-0.1.tar.gz')
         self.runbzr('export ../source-0.1.tar.bz2')
+        self.runbzr('export ../source-0.1')
         self.runbzr('init ../import')
         os.chdir('../import')
         self.runbzr('import ../source-0.1.tar.gz')
@@ -144,6 +145,8 @@
         self.failUnlessExists('import3/src/myfile')
         self.runbzr('import source-0.1.tar.bz2 import4')
         self.failUnlessExists('import4/src/myfile')
+        self.runbzr('import source-0.1 import5')
+        self.failUnlessExists('import5/src/myfile')
 
 def test_suite():
     return makeSuite(TestBzrTools)

=== modified file 'tests/upstream_import.py'
--- tests/upstream_import.py	2007-01-08 15:58:30 +0000
+++ tests/upstream_import.py	2007-01-08 17:08:42 +0000
@@ -165,13 +165,10 @@
     def test_copydir_nosub(self):
         def builder(fileobj, mode='w'):
             return DirFileWriter(fileobj, mode)
+        # It would be bogus to test with the result in a subdirectory,
+        # because for directories, the input root is always the output root.
         self.archive_test(builder, import_dir)
 
-    def test_copydir_sub(self):
-        def builder(fileobj, mode='w'):
-            return DirFileWriter(fileobj, mode)
-        self.archive_test(builder, import_dir, subdir=True)
-
     def archive_test(self, builder, importer, subdir=False):
         archive_file = self.make_archive(builder, subdir)
         tree = BzrDir.create_standalone_workingtree('tree')

=== modified file 'upstream_import.py'
--- upstream_import.py	2007-01-08 15:58:30 +0000
+++ upstream_import.py	2007-01-08 17:08:42 +0000
@@ -11,7 +11,8 @@
 from bzrlib import generate_ids
 from bzrlib.bzrdir import BzrDir
 from bzrlib.errors import NoSuchFile, BzrCommandError, NotBranchError
-from bzrlib.osutils import pathjoin, isdir, file_iterator, basename
+from bzrlib.osutils import (pathjoin, isdir, file_iterator, basename,
+                            file_kind)
 from bzrlib.trace import warning
 from bzrlib.transform import TreeTransform, resolve_conflicts, cook_conflicts
 from bzrlib.workingtree import WorkingTree
@@ -87,7 +88,11 @@
     def __init__(self, root, filepath):
         self.fullpath = pathjoin(root, filepath)
         self.root = root
-        self.name = filepath 
+        if filepath != '':
+            self.name = pathjoin(basename(root), filepath)
+        else:
+            print 'root %r' % root
+            self.name = basename(root)
         self.type = None
         stat = os.lstat(self.fullpath)
         self.mode = stat.st_mode
@@ -268,6 +273,10 @@
                 tar_input.close()
         elif source.endswith('.zip'):
             import_zip(tree, open(source, 'rb'))
+        elif file_kind(source) == 'directory':
+            s = StringIO(source)
+            s.seek(0)
+            import_dir(tree, s)
         else:
             raise BzrCommandError('Unhandled import source')
     finally:

